------------------------------------------------------------------------------------------
-- Main file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- Import Lotro librarys --
------------------------------------------------------------------------------------------
import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.UI.Extensions";
import "Turbine.Gameplay";
------------------------------------------------------------------------------------------
-- Import Globals --
------------------------------------------------------------------------------------------
if Turbine.Engine.GetLanguage() == Turbine.Language.German then
	import "Homeopatix.AltHolic.GlobalsDE";
elseif Turbine.Engine.GetLanguage() == Turbine.Language.French then
	import "Homeopatix.AltHolic.GlobalsFR";
elseif Turbine.Engine.GetLanguage() == Turbine.Language.English then
	import "Homeopatix.AltHolic.GlobalsEN";
end
------------------------------------------------------------------------------------------
-- Import Utility --
------------------------------------------------------------------------------------------
import "Homeopatix.AltHolic.Notification";
import "Homeopatix.AltHolic.LoadAndSave";
import "Homeopatix.AltHolic.MinimizedIcon";
import "Homeopatix.AltHolic.VindarPatch";
import "Homeopatix.AltHolic.FCT";
------------------------------------------------------------------------------------------
-- Import initialization --
------------------------------------------------------------------------------------------
import "Homeopatix.AltHolic.Init";
import "Homeopatix.AltHolic.Activation";
------------------------------------------------------------------------------------------
-- Import Scripts --
------------------------------------------------------------------------------------------
import "Homeopatix.AltHolic.Main";
------------------------------------------------------------------------------------------
-- Import UI elements --
------------------------------------------------------------------------------------------
import "Homeopatix.AltHolic.UI";
import "Homeopatix.AltHolic.UIAddNew";
import "Homeopatix.AltHolic.UIShowEquip";
import "Homeopatix.AltHolic.UIShowBag";
import "Homeopatix.AltHolic.UIShowVault";
import "Homeopatix.AltHolic.UIShowSharedStorage";
import "Homeopatix.AltHolic.UISearch";
import "Homeopatix.AltHolic.OptionsWindow";
------------------------------------------------------------------------------------------
-- Import Commands --
------------------------------------------------------------------------------------------
import "Homeopatix.AltHolic.Commands";
------------------------------------------------------------------------------------------
-- Define vars --
------------------------------------------------------------------------------------------
    Player = Turbine.Gameplay.LocalPlayer.GetInstance();
    vaultpack = Player:GetVault();
    sspack = Player:GetSharedStorage();
    backpack = Player:GetBackpack();
    PlayerName = Player:GetName();
    PlayerAlign = Player:GetAlignment(); --1: Free People / 2: Monster Play
    PlayerLvl = Player:GetLevel();
    PlayerAttr = Player:GetAttributes();
    PlayerAlignement = Player:GetAlignment();
    PlayerEquip = Player:GetEquipment();

    if(PlayerAlignement == 1)then
	    PlayerVoc = PlayerAttr:GetVocation();
    else
        PlayerVoc = 0;
    end

    PlayerClass = Player:GetClass();
    PlayerRace = Player:GetRace();
    PlayerCash = PlayerAttr:GetMoney();


vaultHasBeenUpdated = false;
sharedStorageHasBeenUpdated = false;

LoadSettings();
LoadPlayerDatas();
LoadPlayerEquipment();
LoadPlayerVault();
LoadPlayerBags();
LoadSharedStorage();
SavePlayerDatas();
SavePlayerBags();
SavePlayerEquipment();
settings["sessionCash"]["cashStart"] = PlayerDatas[PlayerName].cash;

------------------------------------------------------------------------------------------
-- Load the datas --
------------------------------------------------------------------------------------------
CreateLocalizationInfo();
------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
CreateMainWindow(380, 300);
CreateAddNewWindow();
CreateUIShowBag(PlayerName);
CreateUIShowVault(PlayerName);
CreateUIShowEquip(PlayerName, PlayerAlignement);
CreateUIShowSharedStorage();
GenerateOptionsWindow();
CreateUiSearch(nil);

settings["isShowBagVisible"]["isShowBagVisible"] = false;
settings["isOptionsWindowVisible"]["isOptionsWindowVisible"] = false;
settings["isShowVaultVisible"]["isShowVaultVisible"] = false;
settings["isShowSharedStorageVisible"]["isShowSharedStorageVisible"] = false;
settings["isShowEquipmentVisible"]["isShowEquipmentVisible"] = false;
settings["nameAccount"]["account1"]["isVisible"] = false;
------------------------------------------------------------------------------------------
-- Closing window handler
------------------------------------------------------------------------------------------
UpdateMainWindow();
ClosingTheWindow();
------------------------------------------------------------------------------------------
-- handle minimizeIcon
------------------------------------------------------------------------------------------
if(settings["isWindowVisible"]["isWindowVisible"] == true)then
	MainMinimizedIcon = MinimizedIcon(Images.MinimizedIcon, 32, 32, AltHolicWindow:SetVisible(true));
else
	MainMinimizedIcon = MinimizedIcon(Images.MinimizedIcon, 32, 32, AltHolicWindow:SetVisible(false));
end

MainMinimizedIcon:SetPosition(settings["IconPosition"]["xPosIcon"], settings["IconPosition"]["yPosIcon"]);
MainMinimizedIcon:SetZOrder(0);
MainMinimizedIcon.PositionChanged = function()
	settings["IconPosition"]["xPosIcon"] = MainMinimizedIcon:GetLeft();
	settings["IconPosition"]["yPosIcon"] = MainMinimizedIcon:GetTop();
end