------------------------------------------------------------------------------------------
-- UI file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- Initialize datas
------------------------------------------------------------------------------------------
buttonPlus = {};
centerLabelB = {};
ButtonPlusLabel = {};
centerLabelBLabel = {};
ButtonPlusLab = {};
centerLabelBLab = {};
------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
function CreateMainWindow(widthWind, heightWind)
	AltHolicWindow=Turbine.UI.Lotro.GoldWindow(); 
	AltHolicWindow:SetSize(widthWind, heightWind); 
	AltHolicWindow:SetText(Strings.PluginName); 
	AltHolicWindow.Message11=Turbine.UI.Label(); 
	AltHolicWindow.Message11:SetParent(AltHolicWindow); 
	AltHolicWindow.Message11:SetSize(150,10); 
	AltHolicWindow.Message11:SetPosition(AltHolicWindow:GetWidth()/2 - 75, AltHolicWindow:GetHeight() - 20); 
	AltHolicWindow.Message11:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	AltHolicWindow.Message11:SetText(Strings.PluginText); 
	AltHolicWindow:SetZOrder(0);
	AltHolicWindow:SetWantsKeyEvents(true);
	AltHolicWindow:SetWantsUpdates(true);

	AltHolicWindow:SetPosition(settings["windowPosition"]["xPos"], settings["windowPosition"]["yPos"]);

	------------------------------------------------------------------------------------------
	-- center window
	------------------------------------------------------------------------------------------
	positionLabelVert = 20;
	positionLabelHori = 40;

	if(settings["nameAccount"]["account1"]["name"] == "")then
		DisplayLabel(1, positionLabelVert, positionLabelHori, Strings.PluginAddNew, "AddNew.tga"); 
	end

	if(settings["nameAccount"]["account1"]["name"] ~= "")then
		PopulateWindow(); 
	end

	local totalCash = 0;
	local startCash = 0;
	if(settings["nameAccount"]["account1"]["nbrAlt"] >= 1)then
		for i in pairs(PlayerDatas) do
		    totalCash = totalCash + PlayerDatas[i].cash;
		end

		DisplayCash(totalCash);
		DisplaySessionCash();
		if(settings["displaySpentCash"]["value"] == true)then
			DisplaySpentCash();
		end
	end

	EscapeKeyHandler();
	PositionChangedWindow();

	if(settings["nameAccount"]["account1"]["name"] ~= "")then
		UpdateChecker(); 
	end
end
------------------------------------------------------------------------------------------
-- Update checker
------------------------------------------------------------------------------------------
function UpdateChecker()
	AltHolicWindow.Update = function()
		vaultpack.ItemsRefreshed = function()
			SavePlayerVault();
			UpdateMainWindow();
			vaultHasBeenUpdated = true;
			if(settings["verbose"]["value"] == true)then
				Turbine.Shell.WriteLine(rgb["start"] .. Strings.PluginName .. rgb["clear"] .. " - " .. Strings.PluginVaultSaved);
			end
		end
		vaultpack.ItemAdded = function()
			SavePlayerVault();
			vaultHasBeenUpdated = true;
			if(settings["verbose"]["value"] == true)then
				Turbine.Shell.WriteLine(rgb["start"] .. Strings.PluginName .. rgb["clear"] .. " - " .. Strings.PluginVaultSaved);
			end
		end
		vaultpack.ItemRemoved = function()
			SavePlayerVault();
			vaultHasBeenUpdated = true;
			if(settings["verbose"]["value"] == true)then
				Turbine.Shell.WriteLine(rgb["start"] .. Strings.PluginName .. rgb["clear"] .. " - " .. Strings.PluginVaultSaved);
			end
		end
		sspack.ItemsRefreshed = function()
			SaveSharedStorage();
			UpdateMainWindow();
			sharedStorageHasBeenUpdated = true;
			if(settings["verbose"]["value"] == true)then
				Turbine.Shell.WriteLine(rgb["start"] .. Strings.PluginName .. rgb["clear"] .. " - " .. Strings.PluginSharedStorageSaved);
			end
		end
		sspack.ItemAdded = function()
			SaveSharedStorage();
			sharedStorageHasBeenUpdated = true;
			if(settings["verbose"]["value"] == true)then
				Turbine.Shell.WriteLine(rgb["start"] .. Strings.PluginName .. rgb["clear"] .. " - " .. Strings.PluginSharedStorageSaved);
			end
		end
		sspack.ItemRemoved = function()
			SaveSharedStorage();
			sharedStorageHasBeenUpdated = true;
			if(settings["verbose"]["value"] == true)then
				Turbine.Shell.WriteLine(rgb["start"] .. Strings.PluginName .. rgb["clear"] .. " - " .. Strings.PluginSharedStorageSaved);
			end
		end
		backpack.ItemAdded = function()
			SavePlayerBags();
			if(settings["verbose"]["value"] == true)then
				Turbine.Shell.WriteLine(rgb["start"] .. Strings.PluginName .. rgb["clear"] .. " - " .. Strings.PluginBagSaved);
			end
		end
		backpack.ItemRemoved = function()
			SavePlayerBags();
			if(settings["verbose"]["value"] == true)then
				Turbine.Shell.WriteLine(rgb["start"] .. Strings.PluginName .. rgb["clear"] .. " - " .. Strings.PluginBagSaved);
			end
		end

		UpdateLvl();
		UpdateCash();

		function PlayerEquip:ItemEquipped(sender, args)
			SavePlayerEquipment();
		end
		function PlayerEquip:ItemUnequipped(sender, args)
			SavePlayerEquipment();
		end

		if(settings["nameAccount"]["account1"]["name"] ~= "")then
			CountPlayers = 0;
			for i in pairs(PlayerDatas) do 
				CountPlayers = CountPlayers + 1;
			end
			settings["nameAccount"]["account1"]["nbrAlt"] = CountPlayers;
		end
	end
end
------------------------------------------------------------------------------------------
-- populate window
------------------------------------------------------------------------------------------
function PopulateWindow()
	local posx = 40;
	local posy = 50;

		if(settings["nameAccount"]["account1"]["name"] ~= "")then
			AltHolicWindow.Message4=Turbine.UI.Label(); 
			AltHolicWindow.Message4:SetParent(AltHolicWindow); 
			AltHolicWindow.Message4:SetSize(280,30); 
			AltHolicWindow.Message4:SetPosition(55, 40); 

			longueurName = string.len(settings["nameAccount"]["account1"]["name"])
			if(longueurName > 10)then
				AltHolicWindow.Message4:SetFont(Turbine.UI.Lotro.Font.TrajanProBold25);
			else
				AltHolicWindow.Message4:SetFont(Turbine.UI.Lotro.Font.TrajanProBold30);
			end

			AltHolicWindow.Message4:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
			AltHolicWindow.Message4:SetText(settings["nameAccount"]["account1"]["name"]);
			AltHolicWindow.Message4:SetForeColor(Turbine.UI.Color( 1, 0.7, 0 ));
			--AltHolicWindow.Message4:SetBackColor(Turbine.UI.Color.Lime);
		end

		buttonIsVisible = Turbine.UI.Extensions.SimpleWindow();
		buttonIsVisible:SetParent( AltHolicWindow );
		buttonIsVisible:SetPosition(posx + 260, posy - 3);
		buttonIsVisible:SetSize( 16, 16 );
		buttonIsVisible:SetVisible(true);

		centerLabelIsVisible = Turbine.UI.Label();
		centerLabelIsVisible:SetParent(buttonIsVisible);
		centerLabelIsVisible:SetPosition( 0, 0 );
		centerLabelIsVisible:SetSize( 16, 16  );
		centerLabelIsVisible:SetZOrder(-1);
		centerLabelIsVisible:SetMouseVisible(false);

		-- button enroule et deroule
		if(settings["nameAccount"]["account1"]["name"] ~= "")then
			if(settings["nameAccount"]["account1"]["isVisible"] == true)then
				centerLabelIsVisible:SetBackground(0x41007E26); --- - 0x41007E26 
			else
				centerLabelIsVisible:SetBackground(0x41007E27); -- + 0x41007E27
			end
		end

		buttonIsVisible.MouseClick = function()
			if(settings["nameAccount"]["account1"]["isVisible"] == true)then
				settings["nameAccount"]["account1"]["isVisible"] = false;
			else
				settings["nameAccount"]["account1"]["isVisible"] = true;	
			end
			UpdateMainWindow();
		end

		-- sharedstorage
		buttonIsVisibleSS = Turbine.UI.Extensions.SimpleWindow();
		buttonIsVisibleSS:SetParent( AltHolicWindow );
		buttonIsVisibleSS:SetPosition(40, posy - 10);
		buttonIsVisibleSS:SetSize( 32, 32 );
		buttonIsVisibleSS:SetVisible(true);

		centerLabelIsVisibleSS = Turbine.UI.Label();
		centerLabelIsVisibleSS:SetParent(buttonIsVisibleSS);
		centerLabelIsVisibleSS:SetPosition( 0, 0 );
		centerLabelIsVisibleSS:SetSize( 32, 32  );
		centerLabelIsVisibleSS:SetBackground(0x4111BE35); -- sharedstorage
		centerLabelIsVisibleSS:SetZOrder(-1);
		centerLabelIsVisibleSS:SetMouseVisible(false);

		buttonIsVisibleSS.MouseClick = function()
			if(settings["isShowSharedStorageVisible"]["isShowSharedStorageVisible"] == true)then
				settings["isShowSharedStorageVisible"]["isShowSharedStorageVisible"] = false;
				UIShowSharedStorage:SetVisible(false);
			else
				CreateUIShowSharedStorage();
				UIShowSharedStorage:SetVisible(true);
				settings["isShowSharedStorageVisible"]["isShowSharedStorageVisible"] = true;	
			end
		end
		DisplayLabelCadre(10, 40, posy -10, Strings.PluginSharedStorage1, buttonIsVisibleSS);

		-- search
		buttonIsVisibleSearch = Turbine.UI.Extensions.SimpleWindow();
		buttonIsVisibleSearch:SetParent( AltHolicWindow );
		buttonIsVisibleSearch:SetPosition(posx + 295, posy - 10);
		buttonIsVisibleSearch:SetSize( 32, 32 );
		buttonIsVisibleSearch:SetVisible(true);

		centerLabelIsVisibleSearch = Turbine.UI.Label();
		centerLabelIsVisibleSearch:SetParent(buttonIsVisibleSearch);
		centerLabelIsVisibleSearch:SetPosition( 0, 0 );
		centerLabelIsVisibleSearch:SetSize( 32, 32  );
		centerLabelIsVisibleSearch:SetBackground(0x410D6DC3); -- search loupe
		centerLabelIsVisibleSearch:SetZOrder(-1);
		centerLabelIsVisibleSearch:SetMouseVisible(false);

		buttonIsVisibleSearch.MouseClick = function()
			if(settings["isSearchWindowVisible"]["isSearchWindowVisible"] == true)then
				settings["isSearchWindowVisible"]["isSearchWindowVisible"] = false;
				UIShowSearch:SetVisible(false);
			else
				CreateUiSearch(nil);
				UIShowSearch:SetVisible(true);
				settings["isSearchWindowVisible"]["isSearchWindowVisible"] = true;	
			end
		end

		DisplayLabelCadre(11, posx + 285, posy -10, Strings.PluginSearch2, buttonIsVisibleSearch);

	if(settings["nameAccount"]["account1"]["isVisible"] == true)then
		for i in pairs(PlayerDatas) do 			
			if(settings["nameAccount"]["account1"]["name"] ~= "")then  --- lvl
				AltHolicWindow.Message13=Turbine.UI.Label(); 
				AltHolicWindow.Message13:SetParent(AltHolicWindow); 
				AltHolicWindow.Message13:SetSize(32,32); 
				AltHolicWindow.Message13:SetPosition(posx - 28, posy + 30); 
				AltHolicWindow.Message13:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22);
				AltHolicWindow.Message13:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
				AltHolicWindow.Message13:SetText(tostring(PlayerDatas[i].lvl));
				AltHolicWindow.Message13:SetForeColor(Turbine.UI.Color.Lime);
				AltHolicWindow.Message13:SetBackground(0x4111219B);
				AltHolicWindow.Message13:SetBlendMode(Turbine.UI.BlendMode.Overlay);
				AltHolicWindow.Message13:SetZOrder(2);
			end
			--- display vocation
			buttonDefineHouseLocationPersonal2 = Turbine.UI.Extensions.SimpleWindow();
			buttonDefineHouseLocationPersonal2:SetParent( AltHolicWindow );
			buttonDefineHouseLocationPersonal2:SetPosition(posx + 290, posy + 23);
			buttonDefineHouseLocationPersonal2:SetSize( 45, 45 );
			buttonDefineHouseLocationPersonal2:SetVisible(true);
			
			centerLabelB21 = Turbine.UI.Label();
			centerLabelB21:SetParent(buttonDefineHouseLocationPersonal2);
			centerLabelB21:SetPosition( 0, 0 );
			centerLabelB21:SetSize( 45, 45  );
			centerLabelB21:SetZOrder(5);

			if(settings["nameAccount"]["account1"]["name"] ~= "")then  -- vocation
				if(PlayerDatas[i].voc == 1)then
					centerLabelB21:SetBackground(0x4110DB16);
					DisplaySmallLabel(i, posx + 290, posy + 23, Strings.PluginVocation1);
				end
				if(PlayerDatas[i].voc == 2)then
					centerLabelB21:SetBackground(0x4110DB18);
					DisplaySmallLabel(i, posx + 290, posy + 23, Strings.PluginVocation2);
				end
				if(PlayerDatas[i].voc == 3)then
					centerLabelB21:SetBackground(0x4110DB13);
					DisplaySmallLabel(i, posx + 290, posy + 23, Strings.PluginVocation3);
				end
				if(PlayerDatas[i].voc == 4)then
					centerLabelB21:SetBackground(0x4110DB19);
					DisplaySmallLabel(i, posx + 290, posy + 23, Strings.PluginVocation4);
				end
				if(PlayerDatas[i].voc == 5)then
					centerLabelB21:SetBackground(0x4110DB17);
					DisplaySmallLabel(i, posx + 290, posy + 23, Strings.PluginVocation5);
				end
				if(PlayerDatas[i].voc == 6)then
					centerLabelB21:SetBackground(0x4110DB14);
					DisplaySmallLabel(i, posx + 290, posy + 23, Strings.PluginVocation6);
				end
				if(PlayerDatas[i].voc == 7)then
					centerLabelB21:SetBackground(0x4110DB15);
					DisplaySmallLabel(i, posx + 290, posy + 23, Strings.PluginVocation7);
				end
				centerLabelB21:SetMouseVisible(true);
			end

			if(settings["nameAccount"]["account1"]["name"] ~= "")then
				-- display bag button
				DisplayBag(i, posx + 10, posy, PlayerDatas[i].voc);

				local nbrItemInVault = 0;

				-- display vault button
				DisplayVault(i, posx + 5, posy, PlayerDatas[i].voc)
			end
			---define race
			buttonDefineHouseLocationPersonal = Turbine.UI.Extensions.SimpleWindow();
			buttonDefineHouseLocationPersonal:SetParent( AltHolicWindow );
			buttonDefineHouseLocationPersonal:SetPosition(posx + 9, posy + 30);
			buttonDefineHouseLocationPersonal:SetSize( 32, 32 );
			buttonDefineHouseLocationPersonal:SetVisible(true);

			centerLabelB5 = Turbine.UI.Label();
			centerLabelB5:SetParent(buttonDefineHouseLocationPersonal);
			centerLabelB5:SetPosition( 0, 0 );
			centerLabelB5:SetSize( 32, 32  );
			centerLabelB5:SetZOrder(-1);
			centerLabelB5:SetMouseVisible(false);

				if(settings["nameAccount"]["account1"]["name"] ~= "")then
					--centerLabelB:SetBackground(ResourcePath .. tostring(PlayerDatas[i].cla));
					if(PlayerDatas[i].rac == 81)then
						centerLabelB5:SetBackground(0x4110894A);
					end
					if(PlayerDatas[i].rac == 23)then
						centerLabelB5:SetBackground(0x41108945);
					end
					if(PlayerDatas[i].rac == 65)then
						centerLabelB5:SetBackground(0x41108947);
					end
					if(PlayerDatas[i].rac == 114)then
						centerLabelB5:SetBackground(0x4115920D);
					end
					if(PlayerDatas[i].rac == 120)then
						centerLabelB5:SetBackground(0x411DAE7E);
					end
					if(PlayerDatas[i].rac == 73)then
						centerLabelB5:SetBackground(0x41108946);
					end
					if(PlayerDatas[i].rac == 117)then
						centerLabelB5:SetBackground(0x411C8D6B);
					end

					if(i == PlayerName)then
						-- debut race monster play
						if(PlayerDatas[i].rac == 7)then
							centerLabelB5:SetBackground(ResourcePath .. "Mordor_red.tga");
						end
						if(PlayerDatas[i].rac == 12)then
							centerLabelB5:SetBackground(ResourcePath .. "Mordor_red.tga");
						end
						if(PlayerDatas[i].rac == 6)then
							centerLabelB5:SetBackground(ResourcePath .. "Mordor_red.tga");
						end
						if(PlayerDatas[i].rac == 66)then
							centerLabelB5:SetBackground(ResourcePath .. "Mordor_red.tga");
						end
					else
						-- debut race monster play
						if(PlayerDatas[i].rac == 7)then
							centerLabelB5:SetBackground(ResourcePath .. "Mordor.tga");
						end
						if(PlayerDatas[i].rac == 12)then
							centerLabelB5:SetBackground(ResourcePath .. "Mordor.tga");
						end
						if(PlayerDatas[i].rac == 6)then
							centerLabelB5:SetBackground(ResourcePath .. "Mordor.tga");
						end
						if(PlayerDatas[i].rac == 66)then
							centerLabelB5:SetBackground(ResourcePath .. "Mordor.tga");
						end
					end
				end
			---define classe
			buttonDefineHouseLocationPersonal = Turbine.UI.Extensions.SimpleWindow();
			buttonDefineHouseLocationPersonal:SetParent( AltHolicWindow );
			buttonDefineHouseLocationPersonal:SetPosition(posx + 47, posy + 30);
			buttonDefineHouseLocationPersonal:SetSize( 32, 32 );
			buttonDefineHouseLocationPersonal:SetVisible(true);

			centerLabelB6 = Turbine.UI.Control();
			centerLabelB6:SetParent(buttonDefineHouseLocationPersonal);
			centerLabelB6:SetPosition( 0, 0 );
			centerLabelB6:SetSize( 32, 32  );
			centerLabelB6:SetZOrder(-1);
			centerLabelB6:SetMouseVisible(false);

				if(settings["nameAccount"]["account1"]["name"] ~= "")then  -- class
					--centerLabelB:SetBackground(ResourcePath .. tostring(PlayerDatas[i].cla));
					if(PlayerDatas[i].cla == 162)then
						centerLabelB6:SetBackground(0x410095C2);
					end
					if(PlayerDatas[i].cla == 31)then
						centerLabelB6:SetBackground(0x4110867A);
					end
					if(PlayerDatas[i].cla == 214)then
						centerLabelB6:SetBackground(0x41153604);
					end
					if(PlayerDatas[i].cla == 24)then
						centerLabelB6:SetBackground(0x410095C5);
					end
					if(PlayerDatas[i].cla == 193)then
						centerLabelB6:SetBackground(0x4110867B);
					end
					if(PlayerDatas[i].cla == 40)then
						centerLabelB6:SetBackground(0x410095BB);
					end
					if(PlayerDatas[i].cla == 185)then
						centerLabelB6:SetBackground(0x410095BF);
					end
					if(PlayerDatas[i].cla == 23)then
						centerLabelB6:SetBackground(0x410095B8);
					end
					if(PlayerDatas[i].cla == 172)then
						centerLabelB6:SetBackground(0x410095B5);
					end
					if(PlayerDatas[i].cla == 194)then
						centerLabelB6:SetBackground(0x41108673);
					end

					if(i == PlayerName)then
						-- debut class pour monster play
						if(PlayerDatas[i].cla == 71)then
							centerLabelB6:SetBackground(ResourcePath .. "Faucheur_red.tga");
						end
						if(PlayerDatas[i].cla == 128)then
							centerLabelB6:SetBackground(ResourcePath .. "Profanateur_red.tga");
						end
						if(PlayerDatas[i].cla == 127)then
							centerLabelB6:SetBackground(ResourcePath .. "Araignee_red.tga");
						end
						if(PlayerDatas[i].cla == 179)then
							centerLabelB6:SetBackground(ResourcePath .. "FlecheNoire_red.tga");
						end
						if(PlayerDatas[i].cla == 52)then
							centerLabelB6:SetBackground(ResourcePath .. "ChefDeGuerre_red.tga");
						end
						if(PlayerDatas[i].cla == 126)then
							centerLabelB6:SetBackground(ResourcePath .. "Ouargue_red.tga");
						end
					else
						-- debut class pour monster play
						if(PlayerDatas[i].cla == 71)then
							centerLabelB6:SetBackground(ResourcePath .. "Faucheur.tga");
						end
						if(PlayerDatas[i].cla == 128)then
							centerLabelB6:SetBackground(ResourcePath .. "Profanateur.tga");
						end
						if(PlayerDatas[i].cla == 127)then
							centerLabelB6:SetBackground(ResourcePath .. "Araignee.tga");
						end
						if(PlayerDatas[i].cla == 179)then
							centerLabelB6:SetBackground(ResourcePath .. "FlecheNoire.tga");
						end
						if(PlayerDatas[i].cla == 52)then
							centerLabelB6:SetBackground(ResourcePath .. "ChefDeGuerre.tga");
						end
						if(PlayerDatas[i].cla == 126)then
							centerLabelB6:SetBackground(ResourcePath .. "Ouargue.tga");
						end
					end
				end

			if(settings["nameAccount"]["account1"]["name"] ~= "")then  -- fond for connected player
				AltHolicWindow.Message6=Turbine.UI.Label(); 
				AltHolicWindow.Message6:SetParent(AltHolicWindow); 
				AltHolicWindow.Message6:SetSize(315,32); 
				AltHolicWindow.Message6:SetPosition(127 , posy + 30); 
				AltHolicWindow.Message6:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22);
				AltHolicWindow.Message6:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
				AltHolicWindow.Message6:SetZOrder(1);
				AltHolicWindow.Message6:SetText(i);

					DisplayEquipment(posx + 50, posy + 30, i, PlayerDatas[i].align);

					if(i == PlayerName)then
						if(PlayerDatas[i].rac == 7 or 
							PlayerDatas[i].rac == 12 or
							PlayerDatas[i].rac == 6 or
							PlayerDatas[i].rac == 66)then
							AltHolicWindow.Message6:SetForeColor(Turbine.UI.Color.Gold);
						else
							AltHolicWindow.Message6:SetForeColor(Turbine.UI.Color.Lime);
						end

						AltHolicWindow.Message21=Turbine.UI.Label(); 
						AltHolicWindow.Message21:SetParent(AltHolicWindow); 
						AltHolicWindow.Message21:SetZOrder(-1);

						if(PlayerDatas[i].rac == 7 or 
							PlayerDatas[i].rac == 12 or
							PlayerDatas[i].rac == 6 or
							PlayerDatas[i].rac == 66)then

							AltHolicWindow.Message21:SetSize(370,32); 
							AltHolicWindow.Message21:SetPosition(5 , posy + 30); 
							AltHolicWindow.Message21:SetBackColor(Turbine.UI.Color( 0.9, 1, 0.1, 0.1 ));
						else
							AltHolicWindow.Message21:SetSize(370,32); 
							AltHolicWindow.Message21:SetPosition(5 , posy + 30); 
							AltHolicWindow.Message21:SetBackColor(Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ));
						end

					else
						AltHolicWindow.Message6:SetForeColor(Turbine.UI.Color.White);
					end
			end

			posy = posy + 45;
		end
	end
end