------------------------------------------------------------------------------------------
-- UIShowSearch file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- create the bag window
------------------------------------------------------------------------------------------
function CreateUiSearch(textToSearch)

	local nbrItemInBag = 0;
	local windowHeightSize = 0;
	local windowWidth = 0;

	windowWidth = 400;

	nbrItemInBag = ReturnNbrItemsInBag(textToSearch);
	nbrItemInBag = nbrItemInBag + ReturnNbrItemsInVault(textToSearch);
	nbrItemInBag = nbrItemInBag + ReturnNbrItemsInSharedStorage(textToSearch);

	UIShowSearch=Turbine.UI.Lotro.GoldWindow(); 
	UIShowSearch:SetSize(windowWidth, 600 + 70); 
	UIShowSearch:SetText("Search window"); 
	UIShowSearch:SetPosition((Turbine.UI.Display:GetWidth()-UIShowSearch:GetWidth())/2,(Turbine.UI.Display:GetHeight()-UIShowSearch:GetHeight())/2); 

	UIShowSearch.Message=Turbine.UI.Label(); 
	UIShowSearch.Message:SetParent(UIShowSearch); 
	UIShowSearch.Message:SetSize(150,10); 
	UIShowSearch.Message:SetPosition(UIShowSearch:GetWidth()/2 - 75, UIShowSearch:GetHeight() - 20); 
	UIShowSearch.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	UIShowSearch.Message:SetText(Strings.PluginText); 
	UIShowSearch:SetZOrder(10);
	UIShowSearch:SetWantsKeyEvents(true);
	UIShowSearch:SetVisible(false);

	UIShowSearch.Message=Turbine.UI.Label(); 
	UIShowSearch.Message:SetParent(UIShowSearch); 
	UIShowSearch.Message:SetSize(200,40); 
	UIShowSearch.Message:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18);
	UIShowSearch.Message:SetPosition(UIShowSearch:GetWidth()/2 - 100, UIShowSearch:GetHeight() - 85); 
	UIShowSearch.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	if(textToSearch ~= nil)then
		UIShowSearch.Message:SetText(Strings.PluginSearch1 .. tostring(nbrItemInBag)); 
	end
	UIShowSearch:SetZOrder(10);
	UIShowSearch:SetWantsKeyEvents(true);
	UIShowSearch:SetVisible(false);

	textBoxLines = Turbine.UI.Lotro.TextBox();
	textBoxLines:SetParent( UIShowSearch );
	textBoxLines:SetSize(300, 30); 
	textBoxLines:SetText( "" ); 
	textBoxLines:SetPosition(UIShowSearch:GetWidth()/2 - 150, 50);
	textBoxLines:SetVisible(true);
	textBoxLines:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	textBoxLines:SetForeColor( Turbine.UI.Color.Gold);
	textBoxLines:SetBackColor( Turbine.UI.Color( .9, .5, .7, .5));

	buttonSearch = Turbine.UI.Lotro.GoldButton();
	buttonSearch:SetParent( UIShowSearch );
	buttonSearch:SetPosition(UIShowSearch:GetWidth()/2 - 125, 90);
	buttonSearch:SetSize( 300, 20 );
	buttonSearch:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	buttonSearch:SetText( Strings.PluginSearch2 );
	buttonSearch:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	buttonSearch:SetVisible(true);
	buttonSearch:SetMouseVisible(true);

	buttonSearch.MouseClick = function(sender, args)
		local textToSearch = textBoxLines:GetText();
		CreateUiSearch(textToSearch);
		UIShowSearch:SetVisible(true);
	end

	buttonClose = Turbine.UI.Lotro.GoldButton();
	buttonClose:SetParent( UIShowSearch );
	buttonClose:SetPosition(UIShowSearch:GetWidth()/2 - 125, UIShowSearch:GetHeight() - 50);
	buttonClose:SetSize( 300, 20 );
	buttonClose:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	buttonClose:SetText( Strings.PluginCloseButton );
	buttonClose:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	buttonClose:SetVisible(true);
	buttonClose:SetMouseVisible(true);

	buttonClose.MouseClick = function(sender, args)
		settings["isShowBagVisible"]["isShowBagVisible"] = false;
		UIShowSearch:SetVisible(false);
	end

	centerWindow = {};
	centerWindowName = {};

	-- create the viewport control all it needs is size and position as it is simply used to create viewable bounds for our map
	viewport1=Turbine.UI.Control();
	viewport1:SetParent(UIShowSearch);
	viewport1:SetSize(windowWidth-35, 450);
	viewport1:SetPosition(10, 140);



	-- create the map content for our viewport, again, it only needs size and position as it is just a container for the grid of images
	viewport1.map=Turbine.UI.Control();
	viewport1.map:SetParent(viewport1); -- set the map as a child of the viewport so that it will be bounded by it for drawing purposes
	-- we'll use a 5x4 grid but this obviously could be expanded, or even set up as a recycled array of controls

	--Turbine.Shell.WriteLine("bag : " .. tostring(ReturnNbrItemsInBag(textToSearch)));
	--Turbine.Shell.WriteLine("vault : " .. tostring(ReturnNbrItemsInVault(textToSearch)));
	--Turbine.Shell.WriteLine("share : " .. tostring(ReturnNbrItemsInSharedStorage(textToSearch)));

	heightSizeOfMap = (ReturnNbrItemsInBag(textToSearch) * 76);
	heightSizeOfMap = heightSizeOfMap +( ReturnNbrItemsInVault(textToSearch) * 76);
	heightSizeOfMap = heightSizeOfMap + (ReturnNbrItemsInSharedStorage(textToSearch) * 50) + 20;

	viewport1.map:SetSize(windowWidth-55, heightSizeOfMap + 70); 

	viewport1.map:SetPosition(0,0); -- we'll start off in the upper left


	local posx = 10;
	local posy = 20;

	-- search bag
	if(textToSearch == nil or ReturnNbrItemsInBag(textToSearch) <= 0)then
		-- do nothing
	else
		LabelName=Turbine.UI.Label(); 
		LabelName:SetParent(viewport1.map); 
		LabelName:SetSize(windowWidth - 35, 20); 
		LabelName:SetPosition(10, 0); 
		LabelName:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22);
		LabelName:SetForeColor(Turbine.UI.Color.White);
		LabelName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
		LabelName:SetText( "BackPack" ); 
		LabelName:SetVisible(true);
		LabelName:SetBackColor(Turbine.UI.Color( .8, .5, .6, .5)); -- just to give it a little style
	end

	if(textToSearch == nil)then
		-- do nothing
	else
		for namePlayerToshow in pairs(PlayerBags) do
			for i in pairs(PlayerBags[namePlayerToshow]) do
				if(string.find(PlayerBags[namePlayerToshow][i].N, textToSearch) ~= nil)then
					--Turbine.Shell.WriteLine("bag of : " .. namePlayerToshow .. " : " .. textToSearch .. " Trouver dans le slot : " .. slot);

					if(nameDisplayed == false)then
						LabelName=Turbine.UI.Label(); 
						LabelName:SetParent(viewport1.map); 
						LabelName:SetSize(350,40); 
						LabelName:SetPosition(posx, posy); 
						LabelName:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24);
						LabelName:SetForeColor(Turbine.UI.Color.Gold);
						LabelName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
						LabelName:SetText( namePlayerToshow ); 
						LabelName:SetVisible(true);
						--LabelName:SetBackColor(Turbine.UI.Color.Red); -- just to give it a little style

						nameDisplayed = true;
						posy = posy + 40;
					end

					centerWindow[i] = Turbine.UI.Control();
					centerWindow[i]:SetSize( 32 , 32 );
					centerWindow[i]:SetParent( viewport1.map );
					centerWindow[i]:SetPosition( posx, posy);
					centerWindow[i]:SetVisible( true );
					centerWindow[i]:SetBackground(0x41000001); -- fond grey
					--centerWindow[i]:SetBackColor( Turbine.UI.Color( .9, .5, .7, .5) );

					centerWindowName[i] = Turbine.UI.Control();
					centerWindowName[i]:SetSize( 300 , 32 );
					centerWindowName[i]:SetParent( viewport1.map );
					centerWindowName[i]:SetPosition( posx + 45, posy);
					centerWindowName[i]:SetVisible( true );
					centerWindowName[i]:SetBackColor( Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ) );

					itemTmp = Turbine.UI.Control();
					centerWindow[i].itemTmp = itemTmp;
					itemTmp:SetParent( centerWindow[i] );
					itemTmp:SetSize( 32, 32 );
					itemTmp:SetPosition( 1, 1 );
					itemTmp:SetZOrder(centerWindow[i]:GetZOrder() + 1);
					itemTmp:SetBackground(tonumber(PlayerBags[namePlayerToshow][tostring(i)].Q));
					itemTmp:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp:SetVisible( true );
					itemTmp:SetMouseVisible( true );

					itemTmp1 = Turbine.UI.Control();
					itemTmp1:SetParent( centerWindow[i] );
					itemTmp1:SetSize( 32, 32 );
					itemTmp1:SetPosition( 1, 1 );
					itemTmp1:SetZOrder(centerWindow[i]:GetZOrder() + 1);
					itemTmp1:SetBackground(tonumber(PlayerBags[namePlayerToshow][tostring(i)].B));
					itemTmp1:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp1:SetVisible( true );

					itemTmp2 = Turbine.UI.Control();
					itemTmp2:SetParent( centerWindow[i] );
					itemTmp2:SetSize( 32, 32 );
					itemTmp2:SetPosition( 1, 1 );
					itemTmp2:SetZOrder(centerWindow[i]:GetZOrder() + 1);

					if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].U) == 0)then
							if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 0)then
								if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								else
									itemTmp2:SetBackground(0x41000001); -- fond grex 0x41000001
								end
							end
							if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 1)then
								if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								else
									itemTmp2:SetBackground(0x41000005); -- fond yellow = 0x41000005
								end
							end
							if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 2)then
								if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].S) == 0)then
									itemTmp2:SetBackground(0x41019972);   -- fond orange light
								end
								if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								elseif(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 188 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 27 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 38 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 56)then	
									itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
								elseif(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 28)then	
									if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].B) == 1090519043)then
										itemTmp2:SetBackground(0x41000003); -- fond purple = 0x41000003
									else
										itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004 --------1090519043
									end
								elseif(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 37)then	
									if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].B) == 1090640816)then
										itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
									else
										itemTmp2:SetBackground(0x410EA2A3); -- Legendaire purple = 0x410EA2A3
									end
								elseif(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 50)then	
									itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004
								elseif(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 47)then	
									itemTmp2:SetBackground(0x410030E2); -- dust brown = 0x410030E2
								elseif(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 1 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 10 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 12 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 19 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 22 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 24 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 30 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 34 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 40 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 44 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 106 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 110 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 111 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 233)then	
									itemTmp2:SetBackground(0x410EA2A3); -- Legendaire purple = 0x410EA2A3
								else
									itemTmp2:SetBackground(0x41000003); -- fond purple = 0x41000003
								end
							end
							if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 3)then
								if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								elseif(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 27)then
									itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
								elseif(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 56)then
									itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
								else
									itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004
								end
							end
							if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 4)then
								if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].S) == 0)then
									itemTmp2:SetBackground(0x41000002);
								end
								if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								elseif(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 50)then
									itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004
								elseif(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 16 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 17 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 28 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 48  or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 106 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 171 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 187 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 235)then
									itemTmp2:SetBackground(0x41000002); -- fond green = 0x41000002
								else
									itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
								end
							end
							if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 5)then
								if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 55)then
									if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].B) == 1091591349)then
										itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
									else
										itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44     --- B = 1091591349
									end
								elseif(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 183 or
										tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 279)then
									itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
								elseif(tonumber(PlayerBags[namePlayerToshow][tostring(i)].CAT) == 38)then
									itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
								else
									itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
								end
							end
						else
							itemTmp2:SetBackground(tonumber(PlayerBags[namePlayerToshow][tostring(i)].U));
						end

					itemTmp2:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp2:SetVisible( true );

					itemTmp3 = Turbine.UI.Control();
					itemTmp3:SetParent( centerWindow[i] );
					itemTmp3:SetSize( 32, 32 );
					itemTmp3:SetPosition( 1, 1 );
					itemTmp3:SetZOrder(centerWindow[i]:GetZOrder() + 1);
					if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].S) == 0)then
						if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 1)then
							itemTmp3:SetBackground(0x410030C4);
						end
						if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 2)then
							itemTmp3:SetBackground(0x410030C4);
						end
						if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 3)then
							itemTmp3:SetBackground(0x410030C4);
						end
						if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 4)then
							itemTmp3:SetBackground(0x410030C4);
						end
						if(tonumber(PlayerBags[namePlayerToshow][tostring(i)].QA) == 5)then
							itemTmp3:SetBackground(0x410030C4);
						end
					else
						itemTmp3:SetBackground(tonumber(PlayerBags[namePlayerToshow][tostring(i)].S));
					end
					itemTmp3:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp3:SetVisible( true );

					itemTmp4 = Turbine.UI.Control();
					itemTmp4:SetParent( centerWindow[i] );
					itemTmp4:SetSize( 32, 32 );
					itemTmp4:SetPosition( 1, 1 );
					itemTmp4:SetZOrder(centerWindow[i]:GetZOrder() + 1);
					itemTmp4:SetBackground(tonumber(PlayerBags[namePlayerToshow][tostring(i)].I));
					itemTmp4:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp4:SetVisible( true );

					UIShowBag.Message=Turbine.UI.Label(); 
					UIShowBag.Message:SetParent(centerWindowName[i]); 
					UIShowBag.Message:SetSize(300, 32); 
					UIShowBag.Message:SetPosition( 1, 1); 
					UIShowBag.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
					UIShowBag.Message:SetText(rgb["gold"] .. PlayerBags[namePlayerToshow][tostring(i)].QUA .. rgb["clear"] .. " " .. PlayerBags[namePlayerToshow][tostring(i)].N); 
					UIShowBag.Message:SetBackColor(Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ));
					UIShowBag.Message:SetMarkupEnabled(true);	

					posy = posy + 38;
				end
			end
			nameDisplayed = false;
		end
	end
	posy = posy + 20;

	-- search vault
	if(textToSearch == nil or ReturnNbrItemsInVault(textToSearch) <= 0)then
		-- do nothing
	else
		LabelName=Turbine.UI.Label(); 
		LabelName:SetParent(viewport1.map); 
		LabelName:SetSize(windowWidth - 35, 20); 
		LabelName:SetPosition(posx, posy - 10); 
		LabelName:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22);
		LabelName:SetForeColor(Turbine.UI.Color.White);
		LabelName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
		LabelName:SetText( "Vault" ); 
		LabelName:SetVisible(true);
		LabelName:SetBackColor(Turbine.UI.Color( .8, .5, .6, .5)); -- just to give it a little style
	end
	posy = posy + 10;

	if(textToSearch == nil)then
		-- do nothing
	else
		for namePlayerToshow in pairs(PlayerVault) do
			for i in pairs(PlayerVault[namePlayerToshow]) do
				if(string.find(PlayerVault[namePlayerToshow][i].N, textToSearch) ~= nil)then
					--Turbine.Shell.WriteLine("bag of : " .. namePlayerToshow .. " : " .. textToSearch .. " Trouver dans le slot : " .. slot);

					if(nameDisplayed == false)then
						LabelName=Turbine.UI.Label(); 
						LabelName:SetParent(viewport1.map); 
						LabelName:SetSize(350,40); 
						LabelName:SetPosition(posx, posy); 
						LabelName:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24);
						LabelName:SetForeColor(Turbine.UI.Color.Gold);
						LabelName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
						LabelName:SetText( namePlayerToshow ); 
						LabelName:SetVisible(true);
						--LabelName:SetBackColor(Turbine.UI.Color.Red); -- just to give it a little style

						nameDisplayed = true;
						posy = posy + 40;
					end

					centerWindow[i] = Turbine.UI.Control();
					centerWindow[i]:SetSize( 32 , 32 );
					centerWindow[i]:SetParent( viewport1.map );
					centerWindow[i]:SetPosition( posx, posy);
					centerWindow[i]:SetVisible( true );
					centerWindow[i]:SetBackground(0x41000001); -- fond grey
					--centerWindow[i]:SetBackColor( Turbine.UI.Color( .9, .5, .7, .5) );

					centerWindowName[i] = Turbine.UI.Control();
					centerWindowName[i]:SetSize( 300 , 32 );
					centerWindowName[i]:SetParent( viewport1.map );
					centerWindowName[i]:SetPosition( posx + 45, posy);
					centerWindowName[i]:SetVisible( true );
					centerWindowName[i]:SetBackColor( Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ) );

					itemTmp = Turbine.UI.Control();
					centerWindow[i].itemTmp = itemTmp;
					itemTmp:SetParent( centerWindow[i] );
					itemTmp:SetSize( 32, 32 );
					itemTmp:SetPosition( 1, 1 );
					itemTmp:SetZOrder(centerWindow[i]:GetZOrder() + 1);
					itemTmp:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].Q));
					itemTmp:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp:SetVisible( true );
					itemTmp:SetMouseVisible( true );

					itemTmp1 = Turbine.UI.Control();
					itemTmp1:SetParent( centerWindow[i] );
					itemTmp1:SetSize( 32, 32 );
					itemTmp1:SetPosition( 1, 1 );
					itemTmp1:SetZOrder(centerWindow[i]:GetZOrder() + 1);
					itemTmp1:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].B));
					itemTmp1:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp1:SetVisible( true );

					itemTmp2 = Turbine.UI.Control();
					itemTmp2:SetParent( centerWindow[i] );
					itemTmp2:SetSize( 32, 32 );
					itemTmp2:SetPosition( 1, 1 );
					itemTmp2:SetZOrder(centerWindow[i]:GetZOrder() + 1);

					if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].U) == 0)then
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 0)then
								if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								else
									itemTmp2:SetBackground(0x41000001); -- fond grex 0x41000001
								end
							end
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 1)then
								if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								else
									itemTmp2:SetBackground(0x41000005); -- fond yellow = 0x41000005
								end
							end
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 2)then
								if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].S) == 0)then
									itemTmp2:SetBackground(0x41019972);   -- fond orange light
								end
								if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 188 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 27 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 38 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 56)then	
									itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
								elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 28)then	
									if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].B) == 1090519043)then
										itemTmp2:SetBackground(0x41000003); -- fond purple = 0x41000003
									else
										itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004 --------1090519043
									end
								elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 37)then	
									if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].B) == 1090640816)then
										itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
									else
										itemTmp2:SetBackground(0x410EA2A3); -- Legendaire purple = 0x410EA2A3
									end
								elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 50)then	
									itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004
								elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 47)then	
									itemTmp2:SetBackground(0x410030E2); -- dust brown = 0x410030E2
								elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 1 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 10 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 12 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 19 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 22 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 24 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 30 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 34 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 40 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 44 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 106 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 110 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 111 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 233)then	
									itemTmp2:SetBackground(0x410EA2A3); -- Legendaire purple = 0x410EA2A3
								else
									itemTmp2:SetBackground(0x41000003); -- fond purple = 0x41000003
								end
							end
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 3)then
								if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 27)then
									itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
								elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 56)then
									itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
								else
									itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004
								end
							end
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 4)then
								if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].S) == 0)then
									itemTmp2:SetBackground(0x41000002);
								end
								if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 50)then
									itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004
								elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 16 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 17 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 28 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 48  or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 106 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 171 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 187 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 235)then
									itemTmp2:SetBackground(0x41000002); -- fond green = 0x41000002
								else
									itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
								end
							end
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 5)then
								if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 55)then
									if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].B) == 1091591349)then
										itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
									else
										itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44     --- B = 1091591349
									end
								elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 183 or
										tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 279)then
									itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
								elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 38)then
									itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
								else
									itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
								end
							end
						else
							itemTmp2:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].U));
						end

					itemTmp2:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp2:SetVisible( true );

					itemTmp3 = Turbine.UI.Control();
					itemTmp3:SetParent( centerWindow[i] );
					itemTmp3:SetSize( 32, 32 );
					itemTmp3:SetPosition( 1, 1 );
					itemTmp3:SetZOrder(centerWindow[i]:GetZOrder() + 1);
					if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].S) == 0)then
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 1)then
							itemTmp3:SetBackground(0x410030C4);
						end
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 2)then
							itemTmp3:SetBackground(0x410030C4);
						end
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 3)then
							itemTmp3:SetBackground(0x410030C4);
						end
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 4)then
							itemTmp3:SetBackground(0x410030C4);
						end
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 5)then
							itemTmp3:SetBackground(0x410030C4);
						end
					else
						itemTmp3:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].S));
					end
					itemTmp3:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp3:SetVisible( true );

					itemTmp4 = Turbine.UI.Control();
					itemTmp4:SetParent( centerWindow[i] );
					itemTmp4:SetSize( 32, 32 );
					itemTmp4:SetPosition( 1, 1 );
					itemTmp4:SetZOrder(centerWindow[i]:GetZOrder() + 1);
					itemTmp4:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].I));
					itemTmp4:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp4:SetVisible( true );

					UIShowBag.Message=Turbine.UI.Label(); 
					UIShowBag.Message:SetParent(centerWindowName[i]); 
					UIShowBag.Message:SetSize(300, 32); 
					UIShowBag.Message:SetPosition( 1, 1); 
					UIShowBag.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
					UIShowBag.Message:SetText(rgb["gold"] .. PlayerVault[namePlayerToshow][tostring(i)].QUA .. rgb["clear"] .. " " .. PlayerVault[namePlayerToshow][tostring(i)].N); 
					UIShowBag.Message:SetBackColor(Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ));
					UIShowBag.Message:SetMarkupEnabled(true);	

					posy = posy + 38;
				end
			end
			nameDisplayed = false;
		end
	end
	posy = posy + 20;

	if(textToSearch == nil or ReturnNbrItemsInSharedStorage(textToSearch) <= 0)then
		-- do nothing
	else
		LabelName=Turbine.UI.Label(); 
		LabelName:SetParent(viewport1.map); 
		LabelName:SetSize(windowWidth - 35, 20); 
		LabelName:SetPosition(posx, posy - 10); 
		LabelName:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22);
		LabelName:SetForeColor(Turbine.UI.Color.White);
		LabelName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
		LabelName:SetText( "SharedStorage" ); 
		LabelName:SetVisible(true);
		LabelName:SetBackColor(Turbine.UI.Color( .8, .5, .6, .5)); -- just to give it a little style
	end
	posy = posy + 10;
	nbrItemInSharedSrorage = 0;

	for i in pairs(SharedStorageVault) do
			nbrItemInSharedSrorage = nbrItemInSharedSrorage + 1 ;
	end
	posy = posy + 20;

	if(textToSearch == nil)then
		-- do nothing
	else
			for i=1, nbrItemInSharedSrorage do  
				if(string.find(SharedStorageVault[tostring(i)].N, textToSearch) ~= nil)then
					--Turbine.Shell.WriteLine("bag of : " .. namePlayerToshow .. " : " .. textToSearch .. " Trouver dans le slot : " .. slot);

					centerWindow[i] = Turbine.UI.Control();
					centerWindow[i]:SetSize( 32 , 32 );
					centerWindow[i]:SetParent( viewport1.map );
					centerWindow[i]:SetPosition( posx, posy);
					centerWindow[i]:SetVisible( true );
					centerWindow[i]:SetBackground(0x41000001); -- fond grey
					--centerWindow[i]:SetBackColor( Turbine.UI.Color( .9, .5, .7, .5) );

					centerWindowName[i] = Turbine.UI.Control();
					centerWindowName[i]:SetSize( 300 , 32 );
					centerWindowName[i]:SetParent( viewport1.map );
					centerWindowName[i]:SetPosition( posx + 45, posy);
					centerWindowName[i]:SetVisible( true );
					centerWindowName[i]:SetBackColor( Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ) );

					itemTmp = Turbine.UI.Control();
					centerWindow[i].itemTmp = itemTmp;
					itemTmp:SetParent( centerWindow[i] );
					itemTmp:SetSize( 32, 32 );
					itemTmp:SetPosition( 1, 1 );
					itemTmp:SetZOrder(centerWindow[i]:GetZOrder() + 1);
					itemTmp:SetBackground(tonumber(SharedStorageVault[tostring(i)].Q));
					itemTmp:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp:SetVisible( true );
					itemTmp:SetMouseVisible( true );

					itemTmp1 = Turbine.UI.Control();
					itemTmp1:SetParent( centerWindow[i] );
					itemTmp1:SetSize( 32, 32 );
					itemTmp1:SetPosition( 1, 1 );
					itemTmp1:SetZOrder(centerWindow[i]:GetZOrder() + 1);
					itemTmp1:SetBackground(tonumber(SharedStorageVault[tostring(i)].B));
					itemTmp1:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp1:SetVisible( true );

					itemTmp2 = Turbine.UI.Control();
					itemTmp2:SetParent( centerWindow[i] );
					itemTmp2:SetSize( 32, 32 );
					itemTmp2:SetPosition( 1, 1 );
					itemTmp2:SetZOrder(centerWindow[i]:GetZOrder() + 1);

					if(tonumber(SharedStorageVault[tostring(i)].U) == 0)then
							if(tonumber(SharedStorageVault[tostring(i)].QA) == 0)then
								if(tonumber(SharedStorageVault[tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								else
									itemTmp2:SetBackground(0x41000001); -- fond grex 0x41000001
								end
							end
							if(tonumber(SharedStorageVault[tostring(i)].QA) == 1)then
								if(tonumber(SharedStorageVault[tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								else
									itemTmp2:SetBackground(0x41000005); -- fond yellow = 0x41000005
								end
							end
							if(tonumber(SharedStorageVault[tostring(i)].QA) == 2)then
								if(tonumber(SharedStorageVault[tostring(i)].S) == 0)then
									itemTmp2:SetBackground(0x41019972);   -- fond orange light
								end
								if(tonumber(SharedStorageVault[tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								elseif(tonumber(SharedStorageVault[tostring(i)].CAT) == 188 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 27 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 38 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 56)then	
									itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
								elseif(tonumber(SharedStorageVault[tostring(i)].CAT) == 28)then	
									if(tonumber(SharedStorageVault[tostring(i)].B) == 1090519043)then
										itemTmp2:SetBackground(0x41000003); -- fond purple = 0x41000003
									else
										itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004 --------1090519043
									end
								elseif(tonumber(SharedStorageVault[tostring(i)].CAT) == 37)then	
									if(tonumber(SharedStorageVault[tostring(i)].B) == 1090640816)then
										itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
									else
										itemTmp2:SetBackground(0x410EA2A3); -- Legendaire purple = 0x410EA2A3
									end
								elseif(tonumber(SharedStorageVault[tostring(i)].CAT) == 50)then	
									itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004
								elseif(tonumber(SharedStorageVault[tostring(i)].CAT) == 47)then	
									itemTmp2:SetBackground(0x410030E2); -- dust brown = 0x410030E2
								elseif(tonumber(SharedStorageVault[tostring(i)].CAT) == 1 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 10 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 12 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 19 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 22 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 24 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 30 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 34 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 40 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 44 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 106 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 110 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 111 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 233)then	
									itemTmp2:SetBackground(0x410EA2A3); -- Legendaire purple = 0x410EA2A3
								else
									itemTmp2:SetBackground(0x41000003); -- fond purple = 0x41000003
								end
							end
							if(tonumber(SharedStorageVault[tostring(i)].QA) == 3)then
								if(tonumber(SharedStorageVault[tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								elseif(tonumber(SharedStorageVault[tostring(i)].CAT) == 27)then
									itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
								elseif(tonumber(SharedStorageVault[tostring(i)].CAT) == 56)then
									itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
								else
									itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004
								end
							end
							if(tonumber(SharedStorageVault[tostring(i)].QA) == 4)then
								if(tonumber(SharedStorageVault[tostring(i)].S) == 0)then
									itemTmp2:SetBackground(0x41000002);
								end
								if(tonumber(SharedStorageVault[tostring(i)].CAT) == 55)then
									itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
								elseif(tonumber(SharedStorageVault[tostring(i)].CAT) == 50)then
									itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004
								elseif(tonumber(SharedStorageVault[tostring(i)].CAT) == 16 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 17 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 28 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 48  or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 106 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 171 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 187 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 235)then
									itemTmp2:SetBackground(0x41000002); -- fond green = 0x41000002
								else
									itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
								end
							end
							if(tonumber(SharedStorageVault[tostring(i)].QA) == 5)then
								if(tonumber(SharedStorageVault[tostring(i)].CAT) == 55)then
									if(tonumber(SharedStorageVault[tostring(i)].B) == 1091591349)then
										itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
									else
										itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44     --- B = 1091591349
									end
								elseif(tonumber(SharedStorageVault[tostring(i)].CAT) == 183 or
										tonumber(SharedStorageVault[tostring(i)].CAT) == 279)then
									itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
								elseif(tonumber(SharedStorageVault[tostring(i)].CAT) == 38)then
									itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
								else
									itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
								end
							end
						else
							itemTmp2:SetBackground(tonumber(SharedStorageVault[tostring(i)].U));
						end

					itemTmp2:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp2:SetVisible( true );

					itemTmp3 = Turbine.UI.Control();
					itemTmp3:SetParent( centerWindow[i] );
					itemTmp3:SetSize( 32, 32 );
					itemTmp3:SetPosition( 1, 1 );
					itemTmp3:SetZOrder(centerWindow[i]:GetZOrder() + 1);
					if(tonumber(SharedStorageVault[tostring(i)].S) == 0)then
						if(tonumber(SharedStorageVault[tostring(i)].QA) == 1)then
							itemTmp3:SetBackground(0x410030C4);
						end
						if(tonumber(SharedStorageVault[tostring(i)].QA) == 2)then
							itemTmp3:SetBackground(0x410030C4);
						end
						if(tonumber(SharedStorageVault[tostring(i)].QA) == 3)then
							itemTmp3:SetBackground(0x410030C4);
						end
						if(tonumber(SharedStorageVault[tostring(i)].QA) == 4)then
							itemTmp3:SetBackground(0x410030C4);
						end
						if(tonumber(SharedStorageVault[tostring(i)].QA) == 5)then
							itemTmp3:SetBackground(0x410030C4);
						end
					else
						itemTmp3:SetBackground(tonumber(SharedStorageVault[tostring(i)].S));
					end
					itemTmp3:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp3:SetVisible( true );

					itemTmp4 = Turbine.UI.Control();
					itemTmp4:SetParent( centerWindow[i] );
					itemTmp4:SetSize( 32, 32 );
					itemTmp4:SetPosition( 1, 1 );
					itemTmp4:SetZOrder(centerWindow[i]:GetZOrder() + 1);
					itemTmp4:SetBackground(tonumber(SharedStorageVault[tostring(i)].I));
					itemTmp4:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp4:SetVisible( true );

					UIShowBag.Message=Turbine.UI.Label(); 
					UIShowBag.Message:SetParent(centerWindowName[i]); 
					UIShowBag.Message:SetSize(300, 32); 
					UIShowBag.Message:SetPosition( 1, 1); 
					UIShowBag.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
					UIShowBag.Message:SetText(rgb["gold"] .. SharedStorageVault[tostring(i)].QUA .. rgb["clear"] .. " " .. SharedStorageVault[tostring(i)].N); 
					UIShowBag.Message:SetBackColor(Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ));
					UIShowBag.Message:SetMarkupEnabled(true);	

					posy = posy + 38;
				end
			end
		nameDisplayed = false;
	end

	-- create the vertical scrollbar for our viewport
	vscroll1=Turbine.UI.Lotro.ScrollBar();
	vscroll1:SetParent(UIShowSearch);
	vscroll1:SetOrientation(Turbine.UI.Orientation.Vertical);
	vscroll1:SetPosition(windowWidth-20, 120);
	vscroll1:SetSize(12,viewport1:GetHeight()); -- set width to 12 since it's a "Lotro" style scrollbar and the height is set to match the control that we will be scrolling
	vscroll1:SetBackColor(Turbine.UI.Color(.1,.1,.2)); -- just to give it a little style
	vscroll1:SetMinimum(0);
	vscroll1:SetMaximum(heightSizeOfMap); -- we will allow scrolling the height of the map-the viewport height
	vscroll1:SetValue(0); -- set the initial value
	-- set the ValueChanged event handler to take an action when our value changes, in this case, change the map position relative to the viewport
	vscroll1.ValueChanged=function()
		viewport1.map:SetTop(0-vscroll1:GetValue());
	end

	ClosingTheWindowSearch();
end
function ReturnNbrItemsInBag(textToSearch)
	local nbrItems = 0;

		if(textToSearch == nil)then
		-- do nothing
		else
			for namePlayerToshow in pairs(PlayerBags) do
				for i in pairs(PlayerBags[namePlayerToshow]) do
					if(string.find(PlayerBags[namePlayerToshow][i].N, textToSearch) ~= nil)then
						nbrItems = nbrItems + 1;
					end
				end
			end
		end
	return nbrItems;
end
function ReturnNbrItemsInVault(textToSearch)
	local nbrItems = 0;
	
	if(textToSearch == nil)then
		-- do nothing
		else
			for namePlayerToshow in pairs(PlayerVault) do
				for i in pairs(PlayerVault[namePlayerToshow]) do
					if(string.find(PlayerVault[namePlayerToshow][i].N, textToSearch) ~= nil)then
						nbrItems = nbrItems + 1;
					end
				end
			end
		end
	return nbrItems
end
function ReturnNbrItemsInSharedStorage(textToSearch)
	local nbrItems = 0;

		local nbrItemInSharedSrorage = 0;

		for i in pairs(SharedStorageVault) do
				nbrItemInSharedSrorage = nbrItemInSharedSrorage + 1 ;
		end

		if(textToSearch == nil)then
		-- do nothing
		else
			for i=1, nbrItemInSharedSrorage do  
				if(string.find(SharedStorageVault[tostring(i)].N, textToSearch) ~= nil)then
					nbrItems = nbrItems + 1;
				end
			end
		end
	return nbrItems;
end