------------------------------------------------------------------------------------------
-- UIshowEquip file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
-- create the equipment window
------------------------------------------------------------------------------------------
function CreateUIShowEquip(namePlayerToshow, alignement)	
	UIShowEquip=Turbine.UI.Lotro.GoldWindow(); 
	UIShowEquip:SetSize(600,520); 
	UIShowEquip:SetText(Strings.PluginEquipement1 .. tostring(namePlayerToshow)); 
	UIShowEquip:SetPosition((Turbine.UI.Display:GetWidth()-UIShowEquip:GetWidth())/2,(Turbine.UI.Display:GetHeight()-UIShowEquip:GetHeight())/2); 

	if(PlayerDatas[namePlayerToshow].align == 1)then
		UIShowEquip.Message=Turbine.UI.Label(); 
		UIShowEquip.Message:SetParent(UIShowEquip); 
		UIShowEquip.Message:SetSize(150,10); 
		UIShowEquip.Message:SetPosition(UIShowEquip:GetWidth()/2 - 75, UIShowEquip:GetHeight() - 20); 
		UIShowEquip.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
		UIShowEquip.Message:SetText(Strings.PluginText); 
		UIShowEquip:SetZOrder(10);
		UIShowEquip:SetWantsKeyEvents(true);
		UIShowEquip:SetVisible(false);

			DurabilitySlots = { 
				0x41007eed, -- head
				0x41007eee, -- shoulder
				0x41007ee9, -- back
				0x41007ef0, -- chest
				0x41007ef2, -- gant
				0x41007ef1, -- legs
				0x41007ef5, -- shoes
				0x41007eec, -- distance
				0x41007efb, -- outils 
				0x410e8680, -- class
				0x41007ef6, -- oreille droite
				0x41007ef7, -- oreille gauche
				0x41007eef, -- collier
				0x41007ef8, -- bracelet droite
				0x41007ef9, -- brcelet gauche
				0x41007ef3, -- bague droite
				0x41007ef4, -- bague gauche
				0x41007efa, -- pocket
				0x41007eea, -- weapon
				0x41007eeb -- shield
			};

			Button = { };

			local posy = 40 ;
			local posx = 300;
			for j=1, 20 do
				Button[j] = Turbine.UI.Label(); 
				Button[j]:SetParent( UIShowEquip );
				Button[j]:SetPosition(posx, posy);
				Button[j]:SetSize( 42, 42 );
				Button[j]:SetVisible(true);
				Button[j]:SetBackground(DurabilitySlots[j]);
				Button[j]:SetZOrder(-1);

				posy = posy + 42;
				if(j == 10)then
					posx = 20;
					posy = 40;
				end
			end

			---- cash displayer
			--- cash of the player
			for i in pairs(PlayerDatas) do 
				if(i == namePlayerToshow)then
					cash = PlayerDatas[i].cash;
				end
			end

			gold = math.floor( cash / 100000);
			silver = math.floor( cash / 100) - gold * 1000;
			copper = cash - gold * 100000 - silver * 100;

			LabelGold = Turbine.UI.Label(); 
			LabelGold:SetParent( UIShowEquip );
			LabelGold:SetPosition(UIShowEquip:GetWidth()/2 - 100, UIShowEquip:GetHeight() - 50);
			LabelGold:SetSize( 27, 21 );
			LabelGold:SetVisible(true);
			LabelGold:SetBackground(0x41007e7b);
			LabelGold:SetZOrder(-1);
			LabelGold:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			UIShowEquip.Message=Turbine.UI.Label(); 
			UIShowEquip.Message:SetParent(UIShowEquip); 
			UIShowEquip.Message:SetSize(120, 30); 
			UIShowEquip.Message:SetPosition(UIShowEquip:GetWidth()/2 - 70, UIShowEquip:GetHeight() - 58); 
			UIShowEquip.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
			UIShowEquip.Message:SetFont(Turbine.UI.Lotro.Font.Verdana18);
			UIShowEquip.Message:SetText(gold); 
			UIShowEquip.Message:SetForeColor(Turbine.UI.Color.Gold);

			LabelGold = Turbine.UI.Label(); 
			LabelGold:SetParent( UIShowEquip );
			LabelGold:SetPosition(UIShowEquip:GetWidth()/2 - 23, UIShowEquip:GetHeight() - 50);
			LabelGold:SetSize( 27, 21 );
			LabelGold:SetVisible(true);
			LabelGold:SetBackground(0x41007e7c);
			LabelGold:SetZOrder(-1);
			LabelGold:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			UIShowEquip.Message=Turbine.UI.Label(); 
			UIShowEquip.Message:SetParent(UIShowEquip); 
			UIShowEquip.Message:SetSize(120, 30); 
			UIShowEquip.Message:SetPosition(UIShowEquip:GetWidth()/2 + 7, UIShowEquip:GetHeight() - 58); 
			UIShowEquip.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
			UIShowEquip.Message:SetFont(Turbine.UI.Lotro.Font.Verdana18);
			UIShowEquip.Message:SetText(silver);
			UIShowEquip.Message:SetForeColor(Turbine.UI.Color.Silver);

			LabelGold = Turbine.UI.Label(); 
			LabelGold:SetParent( UIShowEquip );
			LabelGold:SetPosition(UIShowEquip:GetWidth()/2 + 54, UIShowEquip:GetHeight() - 50);
			LabelGold:SetSize( 27, 21 );
			LabelGold:SetVisible(true);
			LabelGold:SetBackground(0x41007e7d);
			LabelGold:SetZOrder(-1);
			LabelGold:SetBlendMode( Turbine.UI.BlendMode.Overlay );

			UIShowEquip.Message=Turbine.UI.Label(); 
			UIShowEquip.Message:SetParent(UIShowEquip); 
			UIShowEquip.Message:SetSize(120, 30); 
			UIShowEquip.Message:SetPosition(UIShowEquip:GetWidth()/2 + 84, UIShowEquip:GetHeight() - 58); 
			UIShowEquip.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
			UIShowEquip.Message:SetFont(Turbine.UI.Lotro.Font.Verdana18);
			UIShowEquip.Message:SetText(copper);
			UIShowEquip.Message:SetForeColor(Turbine.UI.Color( 0.8, 0.4, 0.2));

			--local twmoneyi = { 0x41007e7b, 0x41007e7c, 0x41007e7d }; --gold, silver, copper icon 27x21
			--- end of cash displayer

			local playerLvl = PlayerDatas[namePlayerToshow].lvl;
			nbrLines = 0;
			for i in pairs(PlayerEquipement[namePlayerToshow]) do
				if(i == "Head")then posx = 305 ; posy = 45 ; end
				if(i == "Shoulder")then posx = 305 ; posy = 87 ; end
				if(i == "Back")then posx = 305 ; posy = 129 ; end
				if(i == "Chest")then posx = 305 ; posy = 171 ; end
				if(i == "Gloves")then posx = 305 ; posy = 213 ; end
				if(i == "Legs")then posx = 305 ; posy = 255 ; end
				if(i == "Boots")then posx = 305 ; posy = 297 ; end
				if(i == "RangedWeapon")then posx = 305 ; posy = 339 ; end
				if(i == "CraftTool")then posx = 305 ; posy = 381 ; end
				if(i == "ClassE")then posx = 305 ; posy = 423 ; end

				if(i == "Earring1")then posx = 25 ; posy = 45 ; end
				if(i == "Earring2")then posx = 25 ; posy = 87 ; end
				if(i == "Necklace")then posx = 25 ; posy = 129 ; end
				if(i == "Bracelet1")then posx = 25 ; posy = 171 ; end
				if(i == "Bracelet2")then posx = 25 ; posy = 213 ; end
				if(i == "Ring1")then posx = 25 ; posy = 255 ; end
				if(i == "Ring2")then posx = 25 ; posy = 297 ; end
				if(i == "Pocket")then posx = 25 ; posy = 339 ; end
				if(i == "PrimaryWeapon")then posx = 25 ; posy = 381 ; end
				if(i == "Shield")then posx = 25 ; posy = 423 ; end
				
				if(PlayerEquipement[namePlayerToshow][i].N ~= nil)then
					itemTmp = Turbine.UI.Control();
					itemTmp:SetParent( UIShowEquip );
					itemTmp:SetPosition(posx, posy);
					itemTmp:SetSize( 32, 32 );
					itemTmp:SetBackground(PlayerEquipement[namePlayerToshow][i].Q);
					itemTmp:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp:SetVisible( true );
					itemTmp:SetMouseVisible( true );

					itemTmp1 = Turbine.UI.Control();
					itemTmp1:SetParent( UIShowEquip );
					itemTmp1:SetPosition(posx, posy);
					itemTmp1:SetSize( 32, 32 );
					itemTmp1:SetBackground(PlayerEquipement[namePlayerToshow][i].B);
					itemTmp1:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp1:SetVisible( true );

					itemTmp2 = Turbine.UI.Control();
					itemTmp2:SetParent( UIShowEquip );
					itemTmp2:SetPosition(posx, posy);
					itemTmp2:SetSize( 32, 32 );

					if(PlayerEquipement[namePlayerToshow][i].U == 0)then
						if(playerLvl < 50)then -- define normal background color from quality
							if(PlayerEquipement[namePlayerToshow][i].QA == 0)then
								itemTmp2:SetBackground(0x41000001);
							end
							if(PlayerEquipement[namePlayerToshow][i].QA == 1)then
								itemTmp2:SetBackground(0x41000005);
							end
							if(PlayerEquipement[namePlayerToshow][i].QA == 2)then
								itemTmp2:SetBackground(0x41000003);
							end
							if(PlayerEquipement[namePlayerToshow][i].QA == 3)then
								itemTmp2:SetBackground(0x41000004);
							end
							if(PlayerEquipement[namePlayerToshow][i].QA == 4)then
								itemTmp2:SetBackground(0x41000002);
							end
							if(PlayerEquipement[namePlayerToshow][i].QA == 5)then
								itemTmp2:SetBackground(0x41000001);
							end
						else -- define legendary border
							if(PlayerEquipement[namePlayerToshow][i].QA == 0)then
								itemTmp2:SetBackground(0x410EA2A0);
							end
							if(PlayerEquipement[namePlayerToshow][i].QA == 1)then
								itemTmp2:SetBackground(0x410EA2A2);
							end
							if(PlayerEquipement[namePlayerToshow][i].QA == 2)then
								itemTmp2:SetBackground(0x410EA2A1);
							end
							if(PlayerEquipement[namePlayerToshow][i].QA == 3)then
								itemTmp2:SetBackground(0x410EA255);
							end
							if(PlayerEquipement[namePlayerToshow][i].QA == 4)then
								itemTmp2:SetBackground(0x410EA2A1);
							end
							if(PlayerEquipement[namePlayerToshow][i].QA == 5)then
								itemTmp2:SetBackground(0x41000001);
							end
						end
					else
						itemTmp2:SetBackground(PlayerEquipement[namePlayerToshow][i].U);
					end
					itemTmp2:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp2:SetVisible( true );

					itemTmp3 = Turbine.UI.Control();
					itemTmp3:SetParent( UIShowEquip );
					itemTmp3:SetPosition(posx, posy);
					itemTmp3:SetSize( 32, 32 );
					itemTmp3:SetBackground(PlayerEquipement[namePlayerToshow][i].S);
					itemTmp3:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp3:SetVisible( true );

					itemTmp4 = Turbine.UI.Control();
					itemTmp4:SetParent( UIShowEquip );
					itemTmp4:SetPosition(posx, posy);
					itemTmp4:SetSize( 32, 32 );
					itemTmp4:SetBackground(PlayerEquipement[namePlayerToshow][i].I);
					itemTmp4:SetBlendMode( Turbine.UI.BlendMode.Overlay );
					itemTmp4:SetVisible( true );

					UIShowEquip.Message=Turbine.UI.Label(); 
					UIShowEquip.Message:SetParent(UIShowEquip); 
					UIShowEquip.Message:SetSize(230, 38); 
					UIShowEquip.Message:SetPosition(posx + 40, posy -2); 
					UIShowEquip.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
					UIShowEquip.Message:SetText(PlayerEquipement[namePlayerToshow][i].N); 
					UIShowEquip.Message:SetBackColor(Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ));
					UIShowEquip.Message:SetMarkupEnabled(true);

					nbrLines = nbrLines + 1;
				else
					UIShowEquip.Message=Turbine.UI.Label(); 
					UIShowEquip.Message:SetParent(UIShowEquip); 
					UIShowEquip.Message:SetSize(230, 38); 
					UIShowEquip.Message:SetPosition(posx + 50, posy); 
					UIShowEquip.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
					UIShowEquip.Message:SetText(Strings.PluginEquipement2); 
					UIShowEquip.Message:SetForeColor(Turbine.UI.Color.Red);
				end
			end
	else
		UIShowEquip.Message2 =Turbine.UI.Label(); 
		UIShowEquip.Message2:SetParent(UIShowEquip); 
		UIShowEquip.Message2:SetSize(400,50); 
		UIShowEquip.Message2:SetPosition(UIShowEquip:GetWidth()/2 - 200, UIShowEquip:GetHeight() - 50); 
		UIShowEquip.Message2:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36);
		UIShowEquip.Message2:SetForeColor(Turbine.UI.Color.Gold);
		UIShowEquip.Message2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
		UIShowEquip.Message2:SetText(Strings.PluginISeeYou); 
		UIShowEquip:SetZOrder(1000);
		UIShowEquip:SetVisible(false);

		SauronWindow = Turbine.UI.Extensions.SimpleWindow();
		SauronWindow:SetParent( UIShowEquip );
		SauronWindow:SetPosition(UIShowEquip:GetWidth()/2 - 280, UIShowEquip:GetHeight()/2 - 225);
		SauronWindow:SetSize( 560, 440 );
		SauronWindow:SetBackground(ResourcePath .. "Sauron.tga");
		--SauronWindow:SetBackColor(Turbine.UI.Color.Red);
		SauronWindow:SetZOrder(12);
		SauronWindow:SetVisible(true);
	end

	ClosingTheWindowEquipment();
end