------------------------------------------------------------------------------------------
-- GloUIShowVaultbalFR file
-- Written by Homeopatix
-- 26 january 2021
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- create the vault window
------------------------------------------------------------------------------------------
function CreateUIShowVault(namePlayerToshow)
	local player = Turbine.Gameplay.LocalPlayer.GetInstance();

	local nbrItemInVault = 0;
	local windowHeightSize = 0;
	local windowWidth = 0;

	windowWidth = 400;

	for i in pairs(PlayerVault[namePlayerToshow]) do
			nbrItemInVault = nbrItemInVault + 1 ;
	end

	windowHeightSize = nbrItemInVault * 38 + 80;

	UIShowVault=Turbine.UI.Lotro.GoldWindow(); 
	if(windowHeightSize < 600)then
		UIShowVault:SetSize(windowWidth, windowHeightSize + 70); 
	else
		UIShowVault:SetSize(windowWidth, 600 + 70); 
	end

	UIShowVault:SetText(Strings.PluginVault1 .. tostring(namePlayerToshow)); 
	UIShowVault:SetPosition((Turbine.UI.Display:GetWidth()-UIShowVault:GetWidth())/2,(Turbine.UI.Display:GetHeight()-UIShowVault:GetHeight())/2); 

	UIShowVault.Message=Turbine.UI.Label(); 
	UIShowVault.Message:SetParent(UIShowVault); 
	UIShowVault.Message:SetSize(150,10); 
	UIShowVault.Message:SetPosition(UIShowVault:GetWidth()/2 - 75, UIShowVault:GetHeight() - 20); 
	UIShowVault.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	UIShowVault.Message:SetText( Strings.PluginText ); 
	UIShowVault:SetZOrder(10);
	UIShowVault:SetWantsKeyEvents(true);
	UIShowVault:SetVisible(false);

	UIShowVault.Message=Turbine.UI.Label(); 
	UIShowVault.Message:SetParent(UIShowVault); 
	UIShowVault.Message:SetSize(200,40); 
	UIShowVault.Message:SetPosition(UIShowVault:GetWidth()/2 - 100, UIShowVault:GetHeight() - 90); 
	UIShowVault.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
	UIShowVault.Message:SetText(Strings.PluginVault2 .. nbrItemInVault .. "/" .. Player:GetBackpack():GetSize()); 
	UIShowVault:SetZOrder(10);
	UIShowVault:SetWantsKeyEvents(true);
	UIShowVault:SetVisible(false);

	if(nbrItemInVault == 0)then
		UIShowVault.Message=Turbine.UI.Label(); 
		UIShowVault.Message:SetParent(UIShowVault); 
		UIShowVault.Message:SetSize(300,30); 
		UIShowVault.Message:SetPosition(UIShowVault:GetWidth()/2 - 150, UIShowVault:GetHeight() - 110); 
		UIShowVault.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
		UIShowVault.Message:SetText(Strings.PluginVault3); 
		UIShowVault:SetZOrder(10);
		UIShowVault:SetWantsKeyEvents(true);
		UIShowVault:SetVisible(false);
	end

	buttonClose = Turbine.UI.Lotro.GoldButton();
	buttonClose:SetParent( UIShowVault );
	buttonClose:SetPosition(UIShowVault:GetWidth()/2 - 125, UIShowVault:GetHeight() - 50);
	buttonClose:SetSize( 300, 20 );
	buttonClose:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	buttonClose:SetText( Strings.PluginCloseButton );
	buttonClose:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	buttonClose:SetVisible(true);
	buttonClose:SetMouseVisible(true);

	buttonClose.MouseClick = function(sender, args)
		settings["isShowVaultVisible"]["isShowVaultVisible"] = false;
		UIShowVault:SetVisible(false);
	end

	centerWindow = {};
	centerWindowName = {};

	-- create the viewport control all it needs is size and position as it is simply used to create viewable bounds for our map
	viewport1=Turbine.UI.Control();
	viewport1:SetParent(UIShowVault);

	if(((nbrItemInVault * 38) + 10) < 535)then
		viewport1:SetSize(windowWidth-35,(nbrItemInVault * 38) + 10);
	else
		viewport1:SetSize(windowWidth-55, 535);
	end

	viewport1:SetPosition(10, 40);
	-- create the map content for our viewport, again, it only needs size and position as it is just a container for the grid of images
	viewport1.map=Turbine.UI.Control();
	viewport1.map:SetParent(viewport1); -- set the map as a child of the viewport so that it will be bounded by it for drawing purposes
	viewport1.map:SetSize(windowWidth-55, (nbrItemInVault * 38) + 10); -- we'll use a 5x4 grid but this obviously could be expanded, or even set up as a recycled array of controls
	viewport1.map:SetPosition(0,0); -- we'll start off in the upper left

	local posx = 10;
	local posy = 10;
	if(namePlayerToshow ~= "")then
		for i=1, nbrItemInVault do  

			centerWindow[i] = Turbine.UI.Control();
			centerWindow[i]:SetSize( 32 , 32 );
			centerWindow[i]:SetParent( viewport1.map );
			centerWindow[i]:SetPosition( posx, posy);
			centerWindow[i]:SetVisible( true );
			centerWindow[i]:SetBackground(0x41000001); -- fond grey
			--centerWindow[i]:SetBackColor( Turbine.UI.Color( .9, .5, .7, .5) );

			centerWindowName[i] = Turbine.UI.Control();
			centerWindowName[i]:SetSize( 300 , 32 );
			centerWindowName[i]:SetParent( viewport1.map );
			centerWindowName[i]:SetPosition( posx + 45, posy);
			centerWindowName[i]:SetVisible( true );
			centerWindowName[i]:SetBackColor( Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ) );

			itemTmp = Turbine.UI.Control();
			centerWindow[i].itemTmp = itemTmp;
			itemTmp:SetParent( centerWindow[i] );
			itemTmp:SetSize( 32, 32 );
			itemTmp:SetPosition( 1, 1 );
			itemTmp:SetZOrder(centerWindow[i]:GetZOrder() + 1);
			itemTmp:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].Q));
			itemTmp:SetBlendMode( Turbine.UI.BlendMode.Overlay );
			itemTmp:SetVisible( true );
			itemTmp:SetMouseVisible( true );

			itemTmp1 = Turbine.UI.Control();
			itemTmp1:SetParent( centerWindow[i] );
			itemTmp1:SetSize( 32, 32 );
			itemTmp1:SetPosition( 1, 1 );
			itemTmp1:SetZOrder(centerWindow[i]:GetZOrder() + 1);
			itemTmp1:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].B));
			itemTmp1:SetBlendMode( Turbine.UI.BlendMode.Overlay );
			itemTmp1:SetVisible( true );

			itemTmp2 = Turbine.UI.Control();
			itemTmp2:SetParent( centerWindow[i] );
			itemTmp2:SetSize( 32, 32 );
			itemTmp2:SetPosition( 1, 1 );
			itemTmp2:SetZOrder(centerWindow[i]:GetZOrder() + 1);

			if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].U) == 0)then
					if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 0)then
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 55)then
							itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
						else
							itemTmp2:SetBackground(0x41000001); -- fond grex 0x41000001
						end
					end
					if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 1)then
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 55)then
							itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
						else
							itemTmp2:SetBackground(0x41000005); -- fond yellow = 0x41000005
						end
					end
					if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 2)then
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].S) == 0)then
							itemTmp2:SetBackground(0x41019972);   -- fond orange light
						end
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 55)then
							itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
						elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 188 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 27 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 38 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 56)then	
							itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
						elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 28)then	
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].B) == 1090519043)then
								itemTmp2:SetBackground(0x41000003); -- fond purple = 0x41000003
							else
								itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004 --------1090519043
							end
						elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 37)then	
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].B) == 1090640816)then
								itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
							else
								itemTmp2:SetBackground(0x410EA2A3); -- Legendaire purple = 0x410EA2A3
							end
						elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 50)then	
							itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004
						elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 47)then	
							itemTmp2:SetBackground(0x410030E2); -- dust brown = 0x410030E2
						elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 1 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 10 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 12 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 19 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 22 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 24 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 30 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 34 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 40 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 44 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 106 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 110 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 111 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 233)then	
							itemTmp2:SetBackground(0x410EA2A3); -- Legendaire purple = 0x410EA2A3
						else
							itemTmp2:SetBackground(0x41000003); -- fond purple = 0x41000003
						end
					end
					if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 3)then
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 55)then
							itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
						elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 27)then
							itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
						elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 56)then
							itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
						else
							itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004
						end
					end
					if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 4)then
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].S) == 0)then
							itemTmp2:SetBackground(0x41000002);
						end
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 55)then
							itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44
						elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 50)then
							itemTmp2:SetBackground(0x41000004); -- fond blue = 0x41000004
						elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 16 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 17 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 28 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 48  or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 106 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 171 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 187 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 235)then
							itemTmp2:SetBackground(0x41000002); -- fond green = 0x41000002
						else
							itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
						end
					end
					if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 5)then
						if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 55)then
							if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].B) == 1091591349)then
								itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
							else
								itemTmp2:SetBackground(0x41000E44); -- fond brown = 0x41000E44     --- B = 1091591349
							end
						elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 183 or
								tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 279)then
							itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
						elseif(tonumber(PlayerVault[namePlayerToshow][tostring(i)].CAT) == 38)then
							itemTmp2:SetBackground(0x4101DBB0); -- fond green big corner on the border = 0x4101DBB0
						else
							itemTmp2:SetBackground(0x41105CB5); -- fond specail object venant du cadeau = 0x41105CB5
						end
					end
				else
					itemTmp2:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].U));
				end

			itemTmp2:SetBlendMode( Turbine.UI.BlendMode.Overlay );
			itemTmp2:SetVisible( true );

			itemTmp3 = Turbine.UI.Control();
			itemTmp3:SetParent( centerWindow[i] );
			itemTmp3:SetSize( 32, 32 );
			itemTmp3:SetPosition( 1, 1 );
			itemTmp3:SetZOrder(centerWindow[i]:GetZOrder() + 1);
			if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].S) == 0)then
				if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 1)then
					itemTmp3:SetBackground(0x410030C4);
				end
				if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 2)then
					itemTmp3:SetBackground(0x410030C4);
				end
				if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 3)then
					itemTmp3:SetBackground(0x410030C4);
				end
				if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 4)then
					itemTmp3:SetBackground(0x410030C4);
				end
				if(tonumber(PlayerVault[namePlayerToshow][tostring(i)].QA) == 5)then
					itemTmp3:SetBackground(0x410030C4);
				end
			else
				itemTmp3:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].S));
			end
			itemTmp3:SetBlendMode( Turbine.UI.BlendMode.Overlay );
			itemTmp3:SetVisible( true );

			itemTmp4 = Turbine.UI.Control();
			itemTmp4:SetParent( centerWindow[i] );
			itemTmp4:SetSize( 32, 32 );
			itemTmp4:SetPosition( 1, 1 );
			itemTmp4:SetZOrder(centerWindow[i]:GetZOrder() + 1);
			itemTmp4:SetBackground(tonumber(PlayerVault[namePlayerToshow][tostring(i)].I));
			itemTmp4:SetBlendMode( Turbine.UI.BlendMode.Overlay );
			itemTmp4:SetVisible( true );

			UIShowVault.Message=Turbine.UI.Label(); 
			UIShowVault.Message:SetParent(centerWindowName[i]); 
			UIShowVault.Message:SetSize(300, 32); 
			UIShowVault.Message:SetPosition( 1, 1); 
			UIShowVault.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft); 
			UIShowVault.Message:SetText(rgb["gold"] .. PlayerVault[namePlayerToshow][tostring(i)].QUA .. rgb["clear"] .. " " .. PlayerVault[namePlayerToshow][tostring(i)].N); 
			UIShowVault.Message:SetBackColor(Turbine.UI.Color( 0.9, 0.3, 0.3, 0.3 ));
			UIShowVault.Message:SetMarkupEnabled(true);

			posy = posy + 38;
		end
	end

	-- create the vertical scrollbar for our viewport
	if(((nbrItemInVault * 38) + 10) < 535)then
		viewport1:SetSize(365,(nbrItemInVault * 38) + 10);
	else
		vscroll1=Turbine.UI.Lotro.ScrollBar();
		vscroll1:SetParent(UIShowVault);
		vscroll1:SetOrientation(Turbine.UI.Orientation.Vertical);
		vscroll1:SetPosition(windowWidth-20, 40);
		vscroll1:SetSize(12,viewport1:GetHeight()); -- set width to 12 since it's a "Lotro" style scrollbar and the height is set to match the control that we will be scrolling
		vscroll1:SetBackColor(Turbine.UI.Color(.1,.1,.2)); -- just to give it a little style
		vscroll1:SetMinimum(0);
		vscroll1:SetMaximum(viewport1.map:GetHeight()-viewport1:GetHeight()); -- we will allow scrolling the height of the map-the viewport height
		vscroll1:SetValue(0); -- set the initial value
		-- set the ValueChanged event handler to take an action when our value changes, in this case, change the map position relative to the viewport
		vscroll1.ValueChanged=function()
			viewport1.map:SetTop(0-vscroll1:GetValue());
		end
	end

	ClosingTheWindowVault();
end